# -*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""
__scriptname__ = 'PyMyFTP'
__version__ = '0.00(1)'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
__copyright__ = 'Copyright (C) 2008 masa'


import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import e32
import os
import time
import appuifw
import re
from ftplib import FTP

#### Please change here or INI_FILE.
INI_FILE = 'E:/Data/PyMyFTP.ini'

LIST_FILE = 'E:/Data/PyMyFTP.lst'
log_file  = 'E:/Data/PyMyFTP.log'
log       = 1
image_path = 'E:/Data/fubuki_html/photo/'
host = 'ftp.hogehoge.com'
store_url = 'hoge.hogehoge.com/mypage/photo'
login_id = 'my_id'
login_pw = 'my_password'
#

# other global variables,no need to change
LOGFILE  = ''
TX_LIST  = []
EXIT_FLG = 0


lock = e32.Ao_lock()

def selected_exit():
    global EXIT_FLG
    EXIT_FLG = 1
    lock.signal()

def set_mainmenu():
    appuifw.app.title = unicode(__scriptname__)
    appuifw.app.exit_key_handler = lambda:selected_exit()
    appuifw.app.menu = [(unicode('select from dir_list', 'utf-8'), from_dirlist), 
						(unicode('use LIST_FILE', 'utf-8'),from_listfile),
						(unicode('exit', 'utf-8'), selected_exit)]

def set_submenu():
    appuifw.app.exit_key_handler = lambda:lock.signal()
    appuifw.app.menu = [(unicode('OK', 'utf-8'),lock.signal ),
						(unicode('exit', 'utf-8'), lock.signal)]

def disp_msg(msg,fontsize='dense'):
    body = appuifw.Text()
    appuifw.app.body = body
    body.color = 0x000000
    body.font = fontsize
    body.add(unicode(str(msg),'utf-8'))


def disp_startmsg():
    msg = '    ** My FTP Tool **\n\n'
    msg = msg + 'App name : ' + __scriptname__ + '\n'
    msg = msg + 'Ver : ' + __version__ + '\n'
    msg = msg + __web__  +'\n'
    msg = msg + __copyright__ + '\n'
    msg = msg + '\nselect option for start'
    disp_msg(msg)


def confread():
    global LIST_FILE
    global image_path
    global log_file
    global log
    global host
    global store_url
    global login_id
    global login_pw
    try:
        f = open(INI_FILE,'r')
        fData = f.read()
        f.close
    except:
        return
        
    
    lnDatalist = fData.split("\n")
    for lnData in lnDatalist:
        lnDtatwk = re.sub("[ \t]+"," ",lnData)
        confData=lnDtatwk.split(" ")
        if confData[0]   == "LIST_FILE" : LIST_FILE  = unicode(confData[1])
        elif confData[0] == "image_path": image_path = unicode(confData[1])
        elif confData[0] == "log_file"  : log_file   = unicode(confData[1])
        elif confData[0] == "log"       : log        = int(confData[1])
        elif confData[0] == "host"      : host       = unicode(confData[1])
        elif confData[0] == "store_url" : store_url  = unicode(confData[1])
        elif confData[0] == "login_id"  : login_id   = unicode(confData[1])
        elif confData[0] == "login_pw"  : login_pw   = unicode(confData[1])


def from_dirlist():
    global EXIT_FLG
    global TX_LIST
    filelist = [x.decode('utf-8') for x in os.listdir(image_path) \
               if os.path.isfile(image_path + x.decode('utf-8'))]
    filelist.sort()
    index = appuifw.multi_selection_list(choices=filelist,search_field=1)
    if index == ():
        EXIT_FLG = 1
    else:
        TX_LIST = [filelist[x] for x in index]
    lock.signal()


def from_listfile():
    global TX_LIST
    global LOGFILE
    FData = ''
    TX_LIST = []
    try:
        F = open(LIST_FILE,'r')
        FData = F.read()
        F.close()
    except:
        LOGFILE = LOGFILE + 'open error LIST_FILE\n'
        lock.signal()
        return #End

    lnData = FData.split("\n")
    TX_LIST = [x.split(" ")[0] for x in lnData if len(x.split(" ")[0]) > 0]
    if TX_LIST == []:
        LOGFILE = LOGFILE + 'no data LIST_FILE\n'

    lock.signal()


def main():
    """メインの関数"""
    global EXIT_FLG
    global LOGFILE
    EXIT_FLG = 0
    LOGFILE  = ''

    confread()

    set_mainmenu()
    disp_startmsg()
    lock.wait()

    if EXIT_FLG == 1:return # EXIT
    if TX_LIST == []:
        set_submenu()
        disp_msg(LOGFILE)
        lock.wait()
        return # EXIT

    try:
        ftp = FTP(host)              # connect to host
        ftp.login(login_id,login_pw) # login
        ftp.cwd(store_url) # change directory where to store the image
    except:
        LOGFILE = LOGFILE + 'host open error\n'
#        ftp.quit()
        set_submenu()
        disp_msg(LOGFILE)
        lock.wait()
        return  # EXIT

    msg = ''
    for file_name in TX_LIST:
        image_file = image_path + file_name
        f_size = os.path.getsize(image_file)
        command = 'STOR %s' % file_name
        msg = LOGFILE + file_name + '  in process\n'
        disp_msg(msg)

        try:
            F = open(image_file,'r')
            ftp.storbinary(command,F,f_size) # store the image
            LOGFILE = LOGFILE + file_name + ' complete\n'
        except:
            LOGFILE = LOGFILE + file_name + ' error\n'
            break
        F.close()
#    else:
#        ftp.quit()

    ftp.quit()
    set_submenu()

    x = time.localtime()
    logtime = str(x[0]) + '-' + str(x[1]) + '-' + str(x[2]) \
              + ' ' + str(x[3]) + ':' + str(x[4])
    LOGFILE = LOGFILE + '  Done! ' + logtime + '\n\n'
    disp_msg(LOGFILE)

    if log == 1:
        LOGF = open(log_file,'a')
        LOGF.write(LOGFILE)
        LOGF.close()
    lock.wait()


if __name__ == '__main__':
    try:
        main()
        appuifw.app.set_exit()
    except:
        raise
